<?php
defined( 'ABSPATH' ) || exit;

class SYSP_GM_Loader {
	private $slug = 'german_market';
	private $file = 'german-market.php';
	private $dir = 'german-market';

	public function __construct(  ) {
		add_filter( 'syncspider_admin_addons', array( $this, 'switch' ), 10, 1 );
		$this->activate_addon();
	}

	public function switch( $settings ) {
		$settings[$this->slug] = array(
			'name'      => 'German Market',
			'description' => 'German market extended support',
            'image' => SYNCSPIDER_PLUGIN_URL . 'addons/german-market/assets/german-market.png',
			'dir' => $this->dir,
			'file'      => $this->file,
			'available' => SYSP_check::check_gm(),
		);

		return $settings;
	}

	private function activate_addon() {
		if ( SYSP_check::check_gm() ) {
			$active_addons = SYSP_check::active_addons();
			if ( isset( $active_addons[ $this->dir ] ) ) {
				require SYNCSPIDER_ADDONS_DIR . DIRECTORY_SEPARATOR . $this->dir . DIRECTORY_SEPARATOR . $this->file;
			}
		}
	}
}
new SYSP_GM_Loader();
