jQuery(document).ready(function ($) {

    $(".syncspider-general__save").on('click', function (e) {
        e.preventDefault();
        var button = $(this);
        var post_meta = $('#syncspider_general_postmeta').val();
        var user_meta = $('#syncspider_general_postmeta').val();
        var sc = $('#syncspider_general_settings_sc').val();
        $.ajax({
            type: 'POST',
            dataType: 'json',
            url: ajaxurl,
            data: {
                'action': 'syncspider_update_general_settings',
                'postmeta': post_meta,
                'usermeta': user_meta,
                'sysp_um': sc
            },
            beforeSend: function () {
                button.removeClass('syncspider_btn_saved').addClass('syncspider_btn_saving');
                button.text(button.data('strsaving'));
            },
            success: function (data) {

                button.removeClass('syncspider_btn_saving').addClass('syncspider_btn_saved');
                button.text(button.data('strsaved'));
                window.location.reload();
            },
            error: function (data) {
                // console.log(data.responseText);
            }
        });
    });


    $(".syncspider-addons__save").on('click', function (e) {
        e.preventDefault();
        var alladdons = [];
        var button = $(this);

        var chk = $('#syncspider-admin-addons input[type="checkbox"]');

        chk.each(function (index, element) {

            alladdons.push(
                {
                    "name": element.name,
                    "checked": element.checked
                }
            );
        });
        $.ajax({
            type: 'POST',
            dataType: 'json',
            url: ajaxurl,
            data: {
                'action': 'syncspider_update_addons',
                'addons': alladdons,
                'sysp_um': $('#syncspider_addons_sc').val()
            },
            beforeSend: function () {
                button.removeClass('syncspider_btn_saved').addClass('syncspider_btn_saving');
                button.text(button.data('strsaving'));
            },
            success: function (data) {

                button.removeClass('syncspider_btn_saving').addClass('syncspider_btn_saved');
                button.text(button.data('strsaved'));
                window.location.reload();
            },
            error: function (data) {
                // console.log(data.responseText);
            }
        });
    });


    function clear_save_button() {
        button = $(".syncspider-metatabs__save");
        button.removeClass('syncspider_btn_saving').removeClass('syncspider_btn_saved').text(button.data('strsave'));
    }


    function sanitizeMetafield(field) {
        var sanitized = field.replace(/[^A-Za-z0-9\s-_]/g, '');
        return sanitized;
    }

    function checkStockField() {
        if ($('#syncspider_woo_new_stock').prop('checked') == true) {
            $('#syncspider_woo_new_stock_number_wrapper').slideDown(200);
        } else {
            $('#syncspider_woo_new_stock_number_wrapper').slideUp(200);
        }

        if ($('#syncspider_woo_decimal_stock').prop('checked') == true) {
            $('#syncspider_woo_new_stock_number').attr('step', '0.001');
        } else {
            $('#syncspider_woo_new_stock_number').attr('step', '1');
        }
    }

    $('#syncspider_woo_new_stock, #syncspider_woo_decimal_stock').on('click', function () {
        setTimeout(checkStockField(), 100);
    });

    $('#syncspider_woo_variation_filter').on('click', function () {
        setTimeout(function () {
            if ($('#syncspider_woo_variation_filter').prop('checked') == true) {
                $('#syncspider_woo_all_pa').slideDown(200);
            } else {
                $('#syncspider_woo_all_pa').slideUp(200);
            }
        }, 100);
    });

    $('#syncspider_woo_field_images').on('click', function () {
        setTimeout(function () {
            if ($('#syncspider_woo_field_images').prop("checked") == true) {
                $('#syncspider_woo_field_images_selected_fields').slideDown(200);
            } else {
                $('#syncspider_woo_field_images_selected_fields').slideUp(200);
            }
        }, 100);
    });

    $('#syncspider_woo_product_pdf').on('click', function () {
        setTimeout(function () {
            if ($('#syncspider_woo_product_pdf').prop('checked') === true) {
                $('#syncspider_woo_checked_product_pdf').slideDown(200);
            } else {
                $("#syncspider_woo_checked_product_pdf").slideUp(200);
            }
        }, 100);
    });

    $('#syncspider_woo_image_checking').on('click', function () {
        setTimeout(function () {
            if ($('#syncspider_woo_image_checking').prop('checked') === true) {
                $('#syncspider_woo_woo_image_checking_fields').slideDown(200);
            } else {
                $('#syncspider_woo_woo_image_checking_fields').slideUp(200);
            }
        }, 100);
    });

    $('#syncspider_woo_image_prevent_update').on('click', function () {
        setTimeout(function () {
            if ($('#syncspider_woo_image_prevent_update').prop('checked') == true) {
                // $("#syncspider_woo_image_check_id_fields").slideUp(200);
            } else {
                // $("#syncspider_woo_image_check_id_fields").slideDown(200);
            }
        }, 100);
    });

    $('.syncspider_show_nag small').on('click', function () {
        $('.syncspider_nag').slideToggle();
    });




    $('#syncspider-general__key').on('click', function (){
        $('#syncspider-general__generate').slideToggle(234);
    });

    $('#syncspider-general__generate > .button').on('click', function (e) {
        e.stopPropagation();
        $('#syncspider-general__key_string').hide();
        $(this).hide();
        $('#syncspider-general__generate_key').css('display', 'inline-block' );
    });

    $('#syncspider-general__generate_manual').on('click', function () {
        setTimeout(function () {
            if ($('#syncspider-general__generate_manual').prop('checked') === true) {
                $('#syncspider-general__generate_manual_key').show();
            } else {
                $('#syncspider-general__generate_manual_key').hide();
            }
        }, 100);
    });

    $('#syncspider-general__generate_cancel').on('click', function (e){
        e.stopPropagation();
        $('#syncspider-general__key_string').show();
        $('#syncspider-general__generate_manual_key input').val('');
        $('#syncspider-general__generate_manual_key').hide();
        $('#syncspider-general__generate_manual').prop( 'checked', false );
        $('#syncspider-general__generate_confirm').val('');
        $('#syncspider-general__generate').hide();
        $('#syncspider-general__generate_key').hide();
        $('#syncspider-general__generate > .button').show();
    });

    $('#syncspider-general__generate-confirm').on('click', function (){

        var btn = $(this);

        var sc = $('#syncspider_general_settings_sc').val();
        var manual = ($('#syncspider-general__generate_manual').prop('checked') === true);
        var manualKey = $('#syncspider-general__generate_manual_key input').val() || "";
        var generate = $('#syncspider-general__generate_confirm').val();

        var msg = $('#syncspider-general__generate-message');

         $.ajax({
            type: 'POST',
            dataType: 'json',
            url: ajaxurl,
            data: {
                'action': 'syncspider_generate_key',
                'manual' : manual,
                'manual_key' : manualKey,
                'generate' : generate,
                'sysp_um': sc
            },
            beforeSend: function () {
                msg.html('').hide();
                btn.addClass('syncspider_btn_saving');
            },
            success: function (response) {
                if(response.success) {
                    msg.css('color', '#000').html(response.data).show();
                    btn.hide();
                    $('#syncspider-general__generate_cancel').hide();
                } else {
                    msg.css('color', 'red').html(response.data).show();
                }

            },
            error: function (data) {
                // console.log(data.responseText);
            },
            complete: function () {
                btn.removeClass('syncspider_btn_saving');
            }
        });
    });


});